﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Threading;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using Microsoft.WindowsAzure.Storage;
using Microsoft.WindowsAzure.Storage.Blob;
using Microsoft.WindowsAzure.Storage.Queue;

namespace BlobStorageDemo
{
    public partial class Default : System.Web.UI.Page
    {
        private CloudStorageAccount storageAccount;
        private CloudBlobClient blobClient;
        private CloudBlobContainer container;

        protected void Page_Load(object sender, EventArgs e)
        {
            storageAccount = CloudStorageAccount.Parse("DefaultEndpointsProtocol=https;AccountName=msfestdemo;AccountKey=CMp2DwzrKWPpDXQbb+nKQnZeQYjdBxO0ML0bQmvAL4ArV8N1aclOUZRL5vggsXSyPPTfZUjuTCeTxTuMCLpBvg==");
            blobClient = storageAccount.CreateCloudBlobClient();

            container = blobClient.GetContainerReference("demo");
            container.CreateIfNotExists(BlobContainerPublicAccessType.Container);

            var files = container.ListBlobs();
            FileList.DataSource = files.Select(f => new
            {
                FileName = Path.GetFileName(f.Uri.AbsoluteUri),
                Url = f.Uri.AbsoluteUri
            });
            FileList.DataBind();
        }

        protected void UploadButton_OnClick(object sender, EventArgs e)
        {
            if (UploadField.HasFiles)
            {
                foreach (var file in UploadField.PostedFiles)
                {
                    var blob = container.GetBlockBlobReference(file.FileName);
                    blob.UploadFromStream(file.InputStream);
                }
            }
            Response.Redirect(Request.RawUrl);
        }

        public void Worker()
        {
            var queueClient = storageAccount.CreateCloudQueueClient();
            var queue = queueClient.GetQueueReference("myqueue");
            queue.CreateIfNotExists();

            queue.AddMessage(new CloudQueueMessage("hello"));

            while (true)
            {
                var message = queue.GetMessage();
                if (message == null)
                {
                    Thread.Sleep(30000);
                    continue;
                }

                if (message.DequeueCount > 3)
                {
                    queue.DeleteMessage(message);
                }
                else
                {
                    // do work
                    queue.DeleteMessage(message);
                }
            }
        }
    }
}